/*** 
 * \file gre/3dvcgeom.h
 * \brief SHAPE_GEOMETRIC3D algorithms
 *
 * \if NODOC
 * $Id: 3dshgeom.h_v 1.1 2007/06/06 17:39:20 vdronov Exp $
 *
 * $Log: 3dshgeom.h_v $
 * Revision 1.1  2007/06/06 17:39:20  vdronov
 * Initial revision
 *
 *
 * \endif
**/ 

#ifndef	INC_GRE_3DSHGEOM_H
#define	INC_GRE_3DSHGEOM_H

#ifndef	INC_GRE_3DGEOMET_H
#include <gre/3dgeomet.h>
#endif

#ifndef	INC_RVC_SHAPE_H
#include <rvc/shape.h>
#endif

#ifndef	INC_GRE_LRSHAPE_H
#include <gre/lrshape.h>
#endif

namespace GRE {

class SHAPE_GEOMETRIC3D : public GEOMETRIC3D {
	public:

		SHAPE_GEOMETRIC3D (			 							  
			);

		virtual ~SHAPE_GEOMETRIC3D (								//! Destructor
			);

		RVC::SHAPE* GetShape () {return &m_Shape; };
		GRE::LAYER_SHAPE* GetShapeLayer () { return m_Layer; };
		double ComputeScale (const INT32 id);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		RVC::SHAPE m_Shape;
		GRE::LAYER_SHAPE *m_Layer;
		DRECT3D ALIGN16(m_Extents);
		SPATREF::COORDREFSYS m_CoordRefSys;
		TRANS2D_MAPGEN m_Transformation;

		SHAPE_GEOMETRIC3D (											//! Copy constructor (not implemented)
			const SHAPE_GEOMETRIC3D& rhs
			);

		SHAPE_GEOMETRIC3D& operator= (								//! Assignment operator (not implemented)
			const SHAPE_GEOMETRIC3D& rhs
			);

		ERRVALUE UpdateExtents (
			TRANS2D_MAPGEN& transformation, 
			DRECT3D& extents
            );

		GEOMETRIC3D* v_CreateInstance (
			) { return new SHAPE_GEOMETRIC3D(); };

		ERRVALUE v_Build (
			const GRE::LAYER *layer
			);

		void v_Free (
			);

		const DRECT3D& v_GetExtents (
			) { return m_Extents; };

		void v_SetCoordRefSys (
			const SPATREF::COORDREFSYS& CoordRefSys
			);

		const SPATREF::COORDREFSYS v_GetCoordRefSys (
			) { return m_CoordRefSys; };

		const TRANS2D_MAPGEN& v_GetTransformationInternalToModel (
			) { return m_Transformation; };

		void OnDrawBegin (	GRE::GEOMETRIC3D_BUILDER* builder, const bool wireframe = false);

		void OnDrawEnd ();


		#endif // GENERATING_DOXYGEN_OUTPUT

	};

}		// End of GRE namespace

#endif



