/**
 * \file rvc/mosaiclayout.h 
 * \brief interface for the RVC::MOSAICLAYOUT class.
 *
 * \if NODOC
 * $Id: mosaiclayout.h_v 1.2 2006/09/08 19:28:21 scowan Exp $
 *
 * $Log: mosaiclayout.h_v $
 * Revision 1.2  2006/09/08 19:28:21  scowan
 * Change enum from serialize to its own enum.
 *
 * Revision 1.1  2005/11/08 16:28:06  scowan
 * Initial revision
 *
 * \endif
**/

//!
//!	\class RVC::MOSAICLAYOUT rvc/mosaiclayout.h
//!	\brief Manages RVC::OBJTYPE_MosaicLayout objects.
//!
//!	The RVC::MOSAICLAYOUT class manages RVC::OBJTYPE_MosaicLayout objects.
//!
//!	RVC Object Types that this class supports: RVC::OBJTYPE_MosaicLayout
//!
//!	Default RVC Object Type for this class: RVC::OBJTYPE_MosaicLayout
//!
//!	Valid parents for this class:
//!		- RVC::OBJTYPE_File
//!		- RVC::OBJTYPE_Folder

#ifndef INC_RVC_MOSAICLAYOUT_H
#define INC_RVC_MOSAICLAYOUT_H

#ifndef INC_RVC_SERIALZE_H
	#include <rvc/serialze.h>
#endif

namespace RVC {

class MOSAICLAYOUT : public RVC::SERIALIZE {
	public:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class MAKEPARMS;
		#endif

		//! Default constructor
		MOSAICLAYOUT (
			);

		//! Copy constructor
		MOSAICLAYOUT (
			const RVC::MOSAICLAYOUT& obj
			);

		//! Destructor
		virtual ~MOSAICLAYOUT (
			);

		//! Assignment
		RVC::MOSAICLAYOUT& operator= (
			const RVC::MOSAICLAYOUT& rhs
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		//! Implementation of RVC::OBJECT virtual methods
		virtual OBJTYPE v_GetDftObjectType ();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};


class MOSAICLAYOUT::MAKEPARMS : public SERIALIZE::MAKEPARMS {
	public:
		MAKEPARMS (
			UINT16 Version = 1				 			//!< Version number to assign to new object
			) : SERIALIZE::MAKEPARMS(OBJTYPE_MosaicLayout, Version, RVC::OBJTYPE_All, DISPPARMUSAGE_Display)
			{}
	};			

}		//! End of RVC namespace

#endif 	//!< INC_RVC_DISPLYT_H
